import java.io.*;
import java.net.*;
import java.util.*;

import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class WebTest {

    private static SimpleReporterAdapter stat
        = new SimpleReporterAdapter("appserver-sqe");
    private static String TEST_NAME = "test";

    private String testSuiteID;
    private String host;
    private String port;
    private String contextRoot;


    public WebTest(String[] args) {
        testSuiteID = args[0];
        host = args[1];
        port = args[2];
        contextRoot = args[3];
        TEST_NAME = testSuiteID;
    }
    
    public static void main(String[] args) {
        stat.addDescription("JPA Validation Tests");	   
        WebTest webTest = new WebTest(args);
        webTest.doTest();
        stat.printSummary(TEST_NAME);
    }

    public void doTest() {     
        try { 
            test("initialize");
            test("validatePersist"); 
            test("validateUpdate"); 
            test("validateRemove"); 
            test("verify"); 
        } catch (Exception ex) {
            System.out.println("Got Ex");
	   // ex.printStackTrace();
        }
    }

    private void test(String c) throws Exception {
        String EXPECTED_RESPONSE = c + ":pass";
        boolean result=false;
        String url = "http://" + host + ":" + port + contextRoot + 
                     "/test?tc=" + c;
        System.out.println("url="+url);

        HttpURLConnection conn = (HttpURLConnection)
	                  (new URL(url)).openConnection();

        int code = conn.getResponseCode();

        if (code != 200) {
            System.err.println("Unexpected return code: " + code);
	} else {
            InputStream is = conn.getInputStream();
            BufferedReader input = new 
	      BufferedReader(new InputStreamReader(is));
	    String line = null;
	    while ((line = input.readLine()) != null) {
	      if (line.contains(EXPECTED_RESPONSE)) {
                result = true;
		break;
	      }
	    }
        }    

	if (result) {
	  stat.addStatus(TEST_NAME + "-" + c, stat.PASS);
	} else {
	  stat.addStatus(TEST_NAME + "-" + c, stat.FAIL);
	}
	
    }


}






