package jpa20.war.bvcallbackbmt.servlet;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

import jpa20.war.bvcallbackbmt.session.TestEJB;

@WebServlet(name="TestServlet", urlPatterns={"/test/*"})
public class TestServlet extends HttpServlet {

    @EJB
    private TestEJB testEJB;

    protected void processRequest(HttpServletRequest request,
                                  HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter out = response.getWriter();
        boolean status = false;
        String testcase = null;
        try {
            out.println("TestServlet at " + request.getContextPath());
            testcase = request.getParameter("tc");
	    System.out.println("testcase = " + testcase);

            if ("initialize".equals(testcase)) {

                status = testEJB.test1();

            } else if ("validatePersist".equals(testcase)) {

                status = testEJB.test2();

            } else if ("validateUpdate".equals(testcase)) {

                status = testEJB.test3();

            } else if ("validateRemove".equals(testcase)) {

                status = testEJB.test4();

            } else if ("verify".equals(testcase)) {

                status = testEJB.test5();

            } else {

                System.out.println("Invalid test case: " + testcase);
                out.println("Invalid test case: " + testcase);

            }
        } catch (Exception ex) {

            System.out.println("Failure in TestServlet");
	    out.println("Failure in TestServlet");

        } finally {
            if (status) 
              out.println(testcase+":pass");
            else
              out.println(testcase+":fail");
            out.close();
        }
    }

    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }


    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    public String getServletInfo() {
        return "TestServlet";
    }

}
